﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;

using Platform.Extensions;

namespace Platform.Extensions
{
    public static class IPEndPointExtensions
    {
        #region To IPEndPoint

        /// <summary>
        /// Parse endpoint
        /// </summary>
        public static IPEndPoint ToIPEndPoint(this string source) { return ToIPEndPoint(source, null); }

        /// <summary>
        /// Parse endpoint
        /// </summary>
        public static IPEndPoint ToIPEndPoint(this string source, IPEndPoint endpoint)
        {
            // check source
            if (source == null || source.Length == 0)
                return endpoint;

            // split into address and port
            string[] items = source.Split(':');
            if (items.Length < 1 || items.Length > 2) return endpoint;
            
            // get adress
            IPAddress address = items[0].Trim().ToIPAddress();
            if (address == null) return endpoint;

            // get port
            int? port = endpoint == null ? (int?)null : endpoint.Port;
            if (items.Length == 2) port = items[1].Trim().ToInt32(10);
            if (port == null) return endpoint;

            // return result
            return new IPEndPoint(address, port.Value);
        }

        #endregion

    }
}
