﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Platform.Extensions
{
    public static class TimestampExtensions
    {
        public static decimal AsVersion(this byte[] source)
        {
            if (source == null || source.Length != 8) return 0;
            return new decimal(BitConverter.ToUInt64(source.Reverse().ToArray(), 0));
        }

        public static byte[] AsTimestamp(this decimal version)
        {
            var result = BitConverter.GetBytes((ulong)version);
            Array.Reverse(result);
            return result;
        }

        public static int Compare(this byte[] b1, byte[] b2)
        {
            var v1 = b1.AsVersion();
            var v2 = b2.AsVersion();
            if (v1 < v2) return -1;
            if (v2 < v1) return 1;
            return 0;
        }
    }
}
