﻿using System;
using System.Diagnostics;
using System.IO;

using Microsoft.Extensions.Configuration;

namespace Platform.Logging
{
    public static class SimpleFileLogger
    {
        public static void WriteLine(string format, params object[] args)
        {
            WriteLine(null, format, args);
        }

        public static void WriteLine( IConfigurationSection configSection, string format, params object[] args )
        {
            try
            {
                format = DateTime.Now.ToString( "dd-MM-yyyy HH:mm:ss.fffff" ) + " " + string.Format(format, args);
                Debug.WriteLine(format);

                var path = configSection?.GetValue<string>("Path");
                if (string.IsNullOrEmpty(path)) path = "c:\\logging";

                var info = new DirectoryInfo("c:\\logging");
                if (!Directory.Exists(path))
                    Directory.CreateDirectory(path);

                path = Path.Combine(path, "LoggingErrors.log");
                System.IO.File.AppendAllText(path, format + "\r\n" );
            }
            catch( Exception ex )
            {
                Debug.WriteLine("Simple File Logging Failed:", ex.Message);
            }
        }
    }
}
