﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Platform.Schedules
{
    public interface ITimeSchedule
    {
        /// <summary>
        /// Gets or sets the start date
        /// </summary>
        DateTime? StartDate { get; set; }

        /// <summary>
        /// Gets or sets the until date
        /// </summary>
        DateTime? UntilDate { get; set; }

        /// <summary>
        /// Timezone Start Time
        /// </summary>
        TimeSpan? StartTime { get; set; }

        /// <summary>
        /// TimeZone Until Time
        /// </summary>
        TimeSpan? UntilTime { get; set; }

        /// <summary>
        /// Returns true if day of week is enabled
        /// </summary>
        /// <param name="day"></param>
        /// <returns></returns>
        bool IsDayEnabled(DayOfWeek day);
    }
}
